<?php
declare(strict_types=1);

namespace Catequil\Db;

use Doctrine\DBAL\Connection;

/**
 * Class ConfigProvider
 *
 * @package Catequil\Db
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-db
 */
final class ConfigProvider
{
    public function __invoke(): array
    {
        return [
            'db' => $this->getDbConfig(),
            'dependencies' => $this->getDependencies(),
        ];
    }

    public function getDbConfig(): array
    {
        return [
            'default_connection' => 'db.default',
            'connections' => [
                'db.default' => [
                    'driver' => '',
                    'host' => '',
                    'user' => '',
                    'password' => '',
                    'dbname' => '',
                ],
            ],
        ];
    }

    public function getDependencies(): array
    {
        return [
            'aliases' => [
                'db' => Connection::class,
            ],
            'abstract_factories' => [
                Container\ConnectionAbstractFactory::class,
            ],
        ];
    }
}