<?php
declare(strict_types=1);

namespace CatequilTest\Db;

use Catequil\Db\ConfigProvider;
use Laminas\ConfigAggregator\ArrayProvider;
use Laminas\ConfigAggregator\ConfigAggregator;
use Laminas\ServiceManager\ServiceManager;
use PHPUnit\Framework\TestCase;
use Psr\Container\ContainerInterface;

/**
 * Class AbstractTestCase
 *
 * @package CatequilTest\Db
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-db
 */
abstract class AbstractTestCase extends TestCase
{
    protected static array $config = [];

    protected static function getContainer(array $config = []): ContainerInterface
    {
        $config = (new ConfigAggregator([
            ConfigProvider::class,
            new ArrayProvider(static::$config),
            new ArrayProvider($config),
        ]))->getMergedConfig();

        $config['dependencies']['services']['config'] = $config;
        return new ServiceManager($config['dependencies']);
    }
}